unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, FileUtil, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, EditBtn, RTTIGrids;

type

  { TTest }

  TTest = class(TPersistent)
  private
    fFilename : TFileName;
    fImage: TImage;
    procedure Setfilename(avalue : TFilename);
    procedure SetImage(const AValue: TImage);
  published
    property Databasename : TFilename read fFilename write Setfilename;
    property image: TImage read fImage write SetImage;
  end;


  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    IBConnection1: TIBConnection;
    Image1: TImage;
    Panel1: TPanel;
    x : TTest;
    TIPropertyGrid1: TTIPropertyGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  x:=TTest.Create;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  TIPropertyGrid1.TIObject:=IBConnection1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TIPropertyGrid1.TIObject:=x;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  x.free;
end;

{ TTest }

procedure TTest.Setfilename(avalue: TFilename);
begin
   if fFilename = avalue then exit;
   fFilename:=avalue;
end;

procedure TTest.SetImage(const AValue: TImage);
begin
  if fImage = AValue then Exit;
  fImage:=AValue;
end;


end.

